/* -----------------------------------------------------------------------------
  GALLY
  Template for Piwigo
  ------------------------------------------------------------------------------
  file: gally/gallyjs-tpp.js
  file release: 1.4.4
  ------------------------------------------------------------------------------
  author: grum at piwigo.org
  << May the Little SpaceFrog be with you >>
  ------------------------------------------------------------------------------
  JS for the pictures pages

  need jQuery 1.2.6

  see the release_notes.txt file for more informations
----------------------------------------------------------------------------- */

var gallyPP=null;

$(document).ready(
  function()
  {
    gallyPP=new GallyPP();
  }
);

function GallyPP () {
  var tabs={
        show:'n',
        current:-1,
        selected:-1
      },
      interface={
        visible:false,
        initialized:0,
        timerDelay:null
      },
      image={
        isScrollable:false,
        highWidth:0,
        highHeight:0,
        leftPos:0,
        zoomMode:''
      },
      container=null,
      initialThumbPos=null,

  /**
   * initialize the object
   */
  init = function()
  {
    var regexp = /[1234567]\./i;

    if(jQuery.browser.msie && jQuery.browser.version.match(regexp))
    {
      // this features don't work with the f*****g msie browser version <= 7.0
      // it seems to be functionnal with ie 8.0
      options.interfaceAnimated="none";
      options.imageAutoScroll=false;
    }

    if(options.imageAutoScroll)
    {
      $("html").css("overflow-x", "hidden");
    }
    else
    {
      $("html").css("overflow-x", "scroll");
    }

    if(options.imageCenterTopBorder == "imageHeaderBar")
    {
      options.imageCenterTopMin+=$("#imageHeaderBar").get(0).offsetTop+$("#imageHeaderBar").get(0).offsetHeight;
    }

    if(!options.interfaceCanSwitch)
    {
      options.interfaceHidden=false;
    }

    image.zoomMode=options.defaultZoomSize;

    switchInterface('0', true);
    initializeImageMode("init");


    if((options.interfaceOnImage=="always" || (options.interfaceOnImage=="noscroll" && !image.isScrollable)) && options.interfaceCanSwitch)
    {
      $("#theMainImage").bind("mouseenter", function () { switchInterface('y', true); } )
                        .bind("mouseleave", function () { switchInterface('n', true); } )
                        .bind("mousemove", function () { switchInterface('y', true); } );
    }

    if(options.interfaceCanSwitch)
    {
      $("#imageHeaderBar").bind("mouseenter", function () { switchInterface('y', false); } )
                          .bind("mousemove", function () { switchInterface('y', false); } );
      $("#imageToolBar").bind("mouseenter", function () { switchInterface('y', true); } )
                        .bind("mouseleave", function () { switchInterface('n', true); } )
                        .bind("mousemove", function () { switchInterface('y', true); } );


      $("#navThumbPrev").bind("mouseenter", function () { switchInterface('Y', true); } )
                        .bind("mouseleave", function () { switchInterface('n', true); } )
                        .bind("mousemove", function () { switchInterface('y', true); } );

      $("#navThumbNext").bind("mouseenter", function () { switchInterface('Y', true); } )
                        .bind("mouseleave", function () { switchInterface('n', true); } )
                        .bind("mousemove", function () { switchInterface('y', true); } );
    }

    $("#contentid").attr("rows", options.commentRows);

    /* fx duration option set to 0 doesn't work so... */
    if(options.animateDelay>0)
    {
      $("#theTabs").tabs({ fx: { opacity: 'toggle', duration:options.animateDelay } } );
    }
    else
    {
      $("#theTabs").tabs();
    }
    switchTabs('n');


    if(options.interfaceCanSwitch)
    {
      $('#theTabsContainer').bind("mouseenter", function () { switchInterface('Y', false); } )
                            .bind("mouseleave", function () { switchInterface('n'); } )
                            .bind("mousemove", function () { switchInterface('y', false); } );
    }

    $("#theTabs").bind('tabsselect', function(event, ui)
      {
        /* The "collapsible" option don't work with jQuery 1.2.6
         * This function aims to reproduct this functionnality
        */
        tabs.selected=ui.index;
      }
    );

    $('.tab a').click(function()
      {
        /* The "collapsible" option don't work with jQuery 1.2.6
         * This function aims to reproduct this functionnality
        */
        $(this).get(0).blur();
        if(tabs.selected == tabs.current)
        {
          if (tabs.current!=-1) switchTabs('n');
          tabs.current=-1;
          tabs.selected=-1;
        }
        else
        {
          if(tabs.current==-1) switchTabs('y');
          tabs.current=tabs.selected;
        }
      }
    );

    $("#icon_derivatives").click(function()
      {
        var elt = $("#derivativeSwitchBox");

        elt.css("left", Math.min( $(this).position().left + $('#tabRandomButtons').outerWidth(true), $(window).width() - elt.outerWidth(true) - 5))
          .css("top", $(this).position().top)
          .toggle();
          $('#iSimpleTip').css('display', 'none'); // if tip activated, hide it..
      }
    );
    $("#derivativeSwitchBox, #privacyLevelBox").on("mouseleave click", function()
      {
        $(this).hide();
      }
    );

    $('#iPrivacyLevelLink').click(function ()
      {
        var elt = $("#privacyLevelBox"),
            ePos = $("#privacyLevelLink");

        elt.css("left", $(this).position().left)
           .css("top", $(this).position().top)
           .toggle();
      }
    );

    $(window).resize( function () { initializeImageMode("resize"); } );

    interface.initialized=1;
    $(document).trigger('gallyInterfaceReady');
  },

  simulateHighRes = function ()
  {
    if(image.isScrollable && options.imageHaveHighRes==false && options.imageSimulateHighRes)
    {
      $('#theImgContainer').bind('click', function ()
        {
          openDisplayHigh($('#theMainImage').attr('src'));
        }
      ).addClass('pointer');
    }

  },

  /**
   * mode = "init" or "resize"
   */
  initializeImageMode = function (mode)
  {
    var thumbWidth=0,
        imgTop=0,
        imgPos='',
        cssValues = new Object;

    cssValues.height = $("#theMainImage").prop("height")+"px";

    // autoscroll
    if(options.imageAutoScroll && ($("#theMainImage").prop("scrollWidth")>($("#theImage").prop("clientWidth")-2*options.marginContainer)))
    {
      cssValues.width = ($("#theImage").prop("clientWidth")- 2*(options.marginContainer+options.paddingContainer))+"px";

      $("#theImage").bind("mousemove",
        function(event){
          if($("#navThumbPrev").length>0) thumbWidth=$("#navThumbPrev").prop("clientWidth");
          deadArea = Math.max(options.imageScrollMinDeadArea, thumbWidth*1.2);
          mouse=Math.max(Math.min(event.clientX-image.leftPos, this.clientWidth - deadArea), deadArea);
          $("#theMainImage")
            .css("left",Math.round(($("#theMainImage").prop("scrollWidth")-this.clientWidth) * -(mouse-deadArea)/(this.clientWidth-2*deadArea))+"px")
            .trigger('scrolled');
        }
      );
      image.isScrollable=true;
    }
    else
    {
      $("#theImage").unbind("mousemove");
      $("#theMainImage").css("left", "0px");
      cssValues.width = $("#theMainImage").prop("scrollWidth")+"px";
      image.isScrollable=false;
    }
    $("#theImgContainer").css(cssValues);

    // imagecenter
    if($("#copyright").css("position")=="fixed")
    {
      $("#theImage").css("padding-bottom", $("#copyright").prop("offsetHeight")+"px");
    }
    switch(options.imageCenterMode)
    {
      case "img":
        imgTop = $("#theImgContainer").prop('offsetHeight');
        break;
      case "all":
        imgTop = $("#theImage").prop('offsetHeight');
        break;
      default:
        imgTop = -10000;
        break;
    }
    imgTop = ($("#copyright").prop("offsetTop") - ($("#imageHeaderBar").prop("offsetTop") + $("#imageHeaderBar").prop("offsetHeight")) - imgTop)/2 + options.imageCenterOffset;

    switch($("#theImage").css("position"))
    {
      case "static":
          $("#theImage").css("padding-top", imgTop);
        break;
      /*
      case "fixed":
      case "absolute":
      case "relative":
      */
      default:
          if(imgTop<options.imageCenterTopMin)
          {
            imgTop=options.imageCenterTopMin;
          }
          imgTop=imgTop+"px";
          $("#theImage").css("top", imgTop);
        break;
    }

    image.leftPos=$('#theImage').offset().left;


    if(mode=="init")
    {
      theHeaderHeight=$("#theHeader").prop("offsetHeight")+$("#theHeaderAlt").prop("offsetHeight");

      $("#imageToolBar").css("top", $("#imageToolBar").prop("offsetTop")+theHeaderHeight+$("#imageHeaderBar").prop("offsetHeight")+"px");

      if($("#navThumbPrev").length>0)
      {
        initialThumbPos=$("#navThumbPrev").position().top;
      }
      else if($("#navThumbNext").length>0)
      {
        initialThumbPos=$("#navThumbNext").position().top;
      }
      else
      {
        initialThumbPos=-1;
      }
    }

    switch(options.tabsPosition)
    {
      case "top":
          toolBarArea = $("#imageToolBar").prop("offsetTop")+$("#imageToolBar").prop("offsetHeight");
          $("#theTabsContainer").css("top", toolBarArea+"px");
        break;
      case "bottom":
          copyrightArea = $("#copyright").prop("clientHeight")+1;
          $("#theTabsContainer").css("bottom", copyrightArea+"px");
        break;
      case "pictureTop":
        $("#theTabsContainer").css(
          {
            top: $("#theMainImage").prop("offsetTop")+"px",
            left:$("#theMainImage").prop("offsetLeft")+"px",
            width:$('#theImgContainer').innerWidth()+"px"
          }
        );
        break;
      case "pictureBottom":
        pictureArea = $("#theMainImage").prop("offsetTop")+$("#theMainImage").prop("offsetHeight");
        $("#theTabsContainer").css(
          {
            top: pictureArea+"px",
            left:$("#theMainImage").prop("offsetLeft")+"px",
            width:$("#theMainImage").prop("offsetWidth")+"px"
          }
        );
        break;
    }

    imgTop=initialThumbPos;
    //if position equals -1, mean top calculate it automatically - valid for "#navThumbPrev" & "#navThumbNext"
    if(imgTop==-1)
    {
      imgTop=$("#theImage").prop("offsetTop")+$("#theHeader").prop("offsetHeight")+$("#theHeaderAlt").prop("offsetHeight")+($("#theImgContainer").height()-$("#navThumbPrev").height())/2;
    }

    $("#navThumbPrev")
        .css("top", imgTop)
        .css("height", $("#copyright").prop("offsetTop")-$("#navThumbPrev").prop("offsetTop")-options.tabsHidden+"px");

    $("#navThumbNext")
        .css("top", imgTop)
        .css("height", $("#copyright").prop("offsetTop")-$("#navThumbNext").prop("offsetTop")-options.tabsHidden+"px");


    $("#theImage").css("top", $("#theImage").prop("offsetTop")+$("#theHeader").prop("offsetHeight")+$("#theHeaderAlt").prop("offsetHeight")+"px");

    simulateHighRes();
  },

  switchInterface = function (show, resetTimer)
  {
    if((interface.initialized==1)&&(options.interfaceHidden))
    {
      interface.initialized=2;
      if(show=="Y") return('');
    }

    if(!options.interfaceHidden && show=="0")  { show="1"; }

    // works with jQuery 1.2.6 (support function need jQuery 1.3)
    if(options.interfaceAnimated=="fade")
    {
      switch(show)
      {
        case '0':
          $(".uiImg").css({opacity: 0, visibility:"hidden"});
          interface.visible=false;
          break;
        case '1':
          if(!interface.visible) $(".uiImg").css({opacity: 1, visibility:"visible"});
          interface.visible=true;
          if(resetTimer) resetInterfaceTimer();
          break;
        case '2':
          //if(interface.visible) break;
        case 'Y':
        case 'y':
          if(!interface.visible) $(".uiImg").css("visibility","visible").stop(true, false).fadeTo(options.animateDelay, 1);
          interface.visible=true;
          if(resetTimer) resetInterfaceTimer();
          break;
        default:
          $(".uiImg").stop(true, false).fadeTo(options.animateDelay, 0, function ()
            {
              this.style.visibility="hidden";
              interface.visible=false;
            }
          );
          clearInterfaceTimer();
          break;
      }
    }
    else
    {
      //other value....
      switch(show)
      {
        case 'y':
        case 'Y':
        case '1':
        case '2':
          if(!interface.visible) $(".uiImg").css("visibility", "visible");
          interface.visible=true;
          if(resetTimer) resetInterfaceTimer();
          break;
        default:
          $(".uiImg").css("visibility", "hidden");
          interface.visible=false;
          clearInterfaceTimer();
          break;
      }
    }
  },

  switchTabs = function(show)
  {
    if(show!='')
    {
      tabs.show=show;
    }
    else
    {
      if(tabs.show!='n')
      {
        tabs.show='n';
      }
      else
      {
        tabs.show='y';
      }
    }

    if(options.tabsAnimated)
    {
      if(tabs.show=='y')
      {
        $("#theTabsContainer").animate({height:options.tabsVisible+"px"}, options.animateDelay).trigger('resize');
      }
      else
      {
        $('#theTabs div.tabPanel').addClass("ui-tabs-hide").css("display", "");
        $('#theTabs li').removeClass("ui-tabs-selected");
        $("#theTabsContainer").animate({height:options.tabsHidden+"px"}, options.animateDelay).trigger('resize');
      }
    }
    else
    {
      if(tabs.show=='y')
      {
        $("#theTabsContainer").css({height:options.tabsVisible+"px"}).trigger('resize');
      }
      else
      {
        $('#theTabs div.tabPanel').addClass("ui-tabs-hide").css("display", "");
        $('#theTabs li').removeClass("ui-tabs-selected");
        $("#theTabsContainer").css({height:options.tabsHidden+"px"}).trigger('resize');
      }
    }
  },

  clearInterfaceTimer = function()
  {
    if(interface.timerDelay!=null)
    {
      window.clearInterval(interface.timerDelay);
      interface.timerDelay=null;
    }
  },

  resetInterfaceTimer = function()
  {
    clearInterfaceTimer();
    if(options.interfaceTimerDelay>0 && options.interfaceCanSwitch) interface.timerDelay=window.setInterval(switchInterface, options.interfaceTimerDelay, "n", false);
  },

  openDisplayHigh = function(url)
  {
    $('#theImageHigh').css(
      {
        width:$("html").get(0).scrollWidth+"px",
        height:$("html").get(0).scrollHeight+"px",
        display:"block"
      }
    );

    if($("#theImgHigh").attr('src')=="")
    {
      p = new Object();
      p.left = (($(window).width()-$("#theImgHighContainer").prop("clientWidth")-options.paddingContainer*2)/2)+"px";
      p.top = (($(window).height()-$("#theImgHighContainer").prop("clientHeight")-options.paddingContainer*2)/2)+"px";


      $('#theImgHighContainer')
        .css(
          {
            left:p.left,
            top:p.top,
            padding:options.paddingContainer+"px"
          }
        );


      $("#theImgHigh")
        .load(
          function ()
          {
            image.highWidth=$("#theImgHigh").width();
            image.highHeight=$("#theImgHigh").height();

            p=calcImgHighPositionAndSize(image.zoomMode);

            $('#theImgHighContainer').css("background-image", "none");
            displayZoomHigh();
            $("#theImgHigh").css( {display:"block"} );
          }
        )
        .attr('src', url);

      if(options.highResClickMode=='close')
      {
        $("#theImgHigh").bind('click', closeDisplayHigh);
      }
      else
      {
        // switch zoom
        $("#theImgHigh").bind('click', switchZoomHigh);
      }
    }
    else
    {
      p=calcImgHighPositionAndSize(image.zoomMode);

      $('#theImgHighContainer')
        .css(
          {
            left:p.left+"px",
            top:p.top+"px",
            width:p.width+"px",
            height:p.height+"px"
          }
        );
    }
  },

  calcImgHighPositionAndSize = function(zoom)
  {
    var p = {
          left:options.marginContainer,
          top:options.marginContainer,
          width:0,
          height:0
        },
        margins = (options.marginContainer+options.paddingContainer)*2;

    if(zoom=='full')
    {
      p.width = $("html").get(0).clientWidth-margins;
      p.height = $("html").get(0).clientHeight-margins;
    }
    else
    {
      //zoom = 'fit'
      ratioImg = image.highWidth / image.highHeight;
      ratioPage = $("html").get(0).clientWidth / $("html").get(0).clientHeight;

      if((ratioPage > 1 && (ratioPage > ratioImg)) ||
         (ratioPage < 1 && (ratioPage < ratioImg)))
      {
        p.height = $("html").get(0).clientHeight-margins;
        p.width = p.height*ratioImg;
      }
      else
      {
        p.width = $("html").get(0).clientWidth-margins;
        p.height = p.width/ratioImg;
      }
      p.left = ($("html").get(0).clientWidth-p.width)/2-options.paddingContainer;
      p.top = ($("html").get(0).clientHeight-p.height)/2-options.paddingContainer;
    }

    if(p.width>image.highWidth)
    {
      p.width = image.highWidth;
      p.left = ($("html").get(0).clientWidth-p.width)/2;
    }
    if(p.height>image.highHeight)
    {
      p.height = image.highHeight;
      p.top = ($("html").get(0).clientHeight-p.height)/2;
    }

    return(p);
  },

  displayZoomHigh = function()
  {
    var container=calcImgHighPositionAndSize(image.zoomMode);

    $('#theImgHighContainer').css(
        {
          left:container.left+"px",
          top:container.top+"px",
          width:container.width+"px",
          height:container.height+"px"
        }
      );



      if(image.zoomMode=="full")
      {
        $("#theImgHigh")
          .css(
            {
              width:image.highWidth+"px",
              height:image.highHeight+"px"
            }
          );
        $('#theImgHighContainer').bind("mousemove",
            function(event)
            {
              var deadArea = Math.max(options.marginContainer*2, options.imageScrollMinDeadArea)
                  mouseX=Math.max(Math.min(event.clientX-container.left, container.width - deadArea), deadArea),
                  mouseY=Math.max(Math.min(event.clientY-container.top, container.height - deadArea), deadArea);
              $("#theImgHigh")
                .css("left",Math.round((image.highWidth-container.width) * -(mouseX-deadArea)/(container.width-2*deadArea))+"px")
                .css("top",Math.round((image.highHeight-container.height) * -(mouseY-deadArea)/(container.height-2*deadArea))+"px");
            }
          );
      }
      else
      {
        $("#theImgHigh")
          .css(
            {
              width:container.width+"px",
              height:container.height+"px",
              left:"0px",
              top:"0px"
            }
          );
        $('#theImgHighContainer').unbind("mousemove");
      }
  },

  closeDisplayHigh = function()
  {
    $('#theImageHigh').css('display', 'none');
  },

  switchZoomHigh = function()
  {
    if(image.zoomMode=='full')
    {
      image.zoomMode="fit";
    }
    else
    {
      image.zoomMode="full";
    }

    $("#theImgHighZoomButton").toggleClass('full').toggleClass('fit');

    displayZoomHigh();
  };

  function changeImgSrc(url,typeSave,typeMap,cookiePath)
  {
    $("#theMainImage")
      .removeAttr("width height")
      .attr("src", url)
      .load(function ()
        {
          initializeImageMode("resize");
        }
      );

    $('#derivativeSwitchBox .switchCheck').css('visibility','hidden');
    $('#derivativeChecked'+typeSave).css('visibility','visible');

    document.cookie = 'picture_deriv='+typeSave+';path='+cookiePath;
  }

  function setPrivacyLevel(rootUrl, id, level)
  {
    var y = new PwgWS(rootUrl);

    y.callService(
      "pwg.images.setPrivacyLevel",
      {image_id: id, level:level} ,
      {
        method: "POST",
        onFailure: function(num, text) { alert(num + " " + text); },
        onSuccess: function(result) {
          jQuery('#privacyLevelBox .switchCheck').css('visibility','hidden');
          jQuery('#levelCheck'+level).css('visibility','visible');
        }
      }
    );
  }

  this.closeDisplayHigh = function () { closeDisplayHigh(); };
  this.switchZoomHigh = function () { switchZoomHigh(); };
  this.getImageProp = function () { return image; };
  this.getInterfaceProp = function () { return interface; };
  this.getTabsProp = function () { return tabs; };
  this.openDisplayHigh = function (url) { openDisplayHigh(url); };
  this.changeImgSrc = function (url,typeSave,typeMap,cookiePath) { changeImgSrc(url,typeSave,typeMap,cookiePath); };
  this.setPrivacyLevel = function (rootUrl, id, level) { setPrivacyLevel(rootUrl, id, level); };

  init();

}




